'TEST.BAS - version 1.51 3/7/09 Copyright Terry Newton
'
'This program benchmarks all warriors in a specified directory using
'benchmark warriors in another directory. Supports coresize 80, 800
'or 8000 with processes, cycles, maxsize and minimum separation
'hard-coded to the values typically used for these core sizes.
'Saves settings in test.ini, delete to restore defaults.
'
'Requires either command-line version of EXHAUST, or PMARS. Permutate
'sequence requires PMARS 0.9.2+ compiled with -DPERMUTATE make switch.
'Simulator binary must be named "exhaust.exe" or "pmars.exe".
'Note - EXHAUST can only be used with random sequence mode, all warriors
'must be in simplified "load" format with no labels other than ORG START,
'and doesn't support END [location]. Useful for sweeping Fizzle warriors.
'
'v1.51 3/7/09 - changed 8000 size/dist back to 100 (oops).
'v1.5 2/28/09 - changes from 1/10/09 v1.4...
' changed distance for coresize 8000 to 200.
' added permutate battle sequence - requires a pmars that supports
'  the -P option or shower of errors. Optimum rounds is displayed
'  when selected, set rounds to this value to cover all combinations
'  of starting position and turn (not practical with coresize 8000).
'v1.4 1/10/09 - changes from 11/13/03 v1.3...
' nano size/distance set to 5 to match current hills
' changed fixed option to -f for fixed sequence (pmars only)
' defaults to PMARS
war$ = "warriors": bench$ = "bench": report$ = "benchrep.txt"
size = 800: rounds = 200: mode$ = "Fixed": warrior$ = ""
exhaust$ = "exhaust.exe": pmars$ = "pmars.exe": sim$ = "PMARS"
self$ = "Disabled": inifile$ = "test.ini": GOSUB loadini
menu:
ON ERROR GOTO errortrap
proc = 800: cycles = 8000: dist = 20
IF size = 8000 THEN proc = 8000: cycles = 80000: dist = 100
IF size = 80 THEN proc = 80: cycles = 800: dist = 5
optround$ = ""
IF mode$ = "Permutate" THEN
 optround$ = " (opt rounds =" + STR$((size - dist * 2 + 1) * 2) + ")"
END IF
CLS
PRINT
PRINT "   Multiple Warrior Tester v1.51"
PRINT
PRINT "   [1] Warrior directory : "; war$
PRINT "   [2] Bench directory   : "; bench$
PRINT "   [3] Coresize          :"; size
PRINT "   [4] Rounds            :"; rounds
PRINT "   [5] Battle sequence   : "; mode$; optround$
PRINT "   [6] Battle self       : "; self$
PRINT "   [7] Simulator         : "; sim$
PRINT "   [8] Report filename   : "; report$
PRINT
PRINT "   [R] Run benchmark"
PRINT "   [C] Continue a benchmark"
PRINT "   [V] View report file"
PRINT "   [S] View sorted report file"
PRINT "   [X] Exit"
PRINT
selected = 0
WHILE selected = 0
 k$ = UCASE$(INKEY$)
 IF k$ <> "" THEN selected = 1
WEND
IF k$ = "1" GOTO chwardir
IF k$ = "2" GOTO chbenchdir
IF k$ = "3" GOTO chsize
IF k$ = "4" GOTO chrounds
IF k$ = "5" GOTO chmode
IF k$ = "6" GOTO chself
IF k$ = "7" GOTO chsim
IF k$ = "8" GOTO chreport
IF k$ = "R" GOTO runbench
IF k$ = "C" GOTO continuebench
IF k$ = "V" GOTO viewreport
IF k$ = "S" GOTO viewsorted
IF k$ = "X" GOTO normalexit
GOTO menu
chwardir:
PRINT "   New warrior directory: "; : LINE INPUT a$
a$ = LTRIM$(RTRIM$(a$)): IF a$ <> "" THEN war$ = a$
GOTO menu
chbenchdir:
PRINT "   New bench directory: "; : LINE INPUT a$
a$ = LTRIM$(RTRIM$(a$)): IF a$ <> "" THEN bench$ = a$
GOTO menu
chsize:
z = 0
IF size = 8000 THEN z = 80
IF size = 800 THEN z = 8000
IF z = 0 THEN z = 800
size = z: GOTO menu
chrounds:
PRINT "   New rounds: "; : LINE INPUT a$
a$ = LTRIM$(RTRIM$(a$)): IF a$ <> "" THEN rounds = VAL(a$)
GOTO menu
chmode:
IF sim$ = "Exhaust" THEN
 mode$ = "Random"
ELSE
 IF mode$ = "Random" THEN
  mode$ = "Fixed"
 ELSE
  IF mode$ = "Fixed" THEN
   mode$ = "Permutate"
  ELSE
   mode$ = "Random"
  END IF
 END IF
END IF
GOTO menu
chself:
IF self$ = "Disabled" THEN self$ = "Enabled" ELSE self$ = "Disabled"
GOTO menu
chsim:
IF sim$ = "Exhaust" THEN
 sim$ = "PMARS"
ELSE
 sim$ = "Exhaust": mode$ = "Random"
END IF
GOTO menu
chreport:
PRINT "   New report filename: "; : LINE INPUT a$
IF a$ <> "" THEN report$ = a$
GOTO menu
normalexit:
CLS : GOSUB saveini: SYSTEM
errortrap:
PRINT "Error"; ERR: CLOSE : SYSTEM

initbench:
'determine sequence option...
extracmd$ = " "
IF mode$ = "Fixed" AND sim$ = "PMARS" THEN extracmd$ = " -f "
IF mode$ = "Permutate" AND sim$ = "PMARS" THEN extracmd$ = " -P "
'create base command line...
basecmd$ = exhaust$
IF sim$ = "PMARS" THEN basecmd$ = pmars$
basecmd$ = basecmd$ + extracmd$ + "-s" + STR$(size) + " -p" + STR$(proc)
basecmd$ = basecmd$ + " -c" + STR$(cycles) + " -d" + STR$(dist)
basecmd$ = basecmd$ + " -r" + STR$(rounds) + " -b "
' if pmars used create a batch to run it in a null shell
' (otherwise non-server versions hang if key is pressed)
IF sim$ = "PMARS" THEN
 basecmd$ = basecmd$ + "-l" + STR$(dist) + " "
 OPEN "pmarstmp.bat" FOR OUTPUT AS #3
 PRINT #3, "@echo off"
 PRINT #3, "%comspec% /c benchtmp.bat %1 < nul > nul"
 CLOSE #3
END IF
'determine what to test.. write list to warlst.tmp
SHELL "dir /-p /on /b " + war$ + "\*.red > warlst.tmp"
'write temp bench batch... benchtmp.bat warriortotest
OPEN "benchtmp.bat" FOR OUTPUT AS #1
PRINT #1, "@echo off"
PRINT #1, "if .%1==.Process goto %1"
PRINT #1, "if exist results.tmp del results.tmp"
PRINT #1, "for %%a in ("; bench$; "\*.red) do call %0 Process %1 %%a"
IF self$ = "Enabled" THEN PRINT #1, "call %0 Process %1 %1"
PRINT #1, "goto End"
PRINT #1, ":Process"
PRINT #1, basecmd$; "%2 %3 >>results.tmp"
PRINT #1, ":End"
CLOSE #1
RETURN

runbench:
GOSUB initbench
'for each warrior to test, run benchtmp.bat, calculate score and
'write to report file
OPEN report$ FOR OUTPUT AS #1
OPEN "warlst.tmp" FOR INPUT AS #2
GOTO benchmark

continuebench:
IF warrior$ = "" THEN GOTO menu
GOSUB initbench
OPEN report$ FOR APPEND AS #1
OPEN "warlst.tmp" FOR INPUT AS #2
found = 0: WHILE NOT EOF(2) AND found = 0
 LINE INPUT #2, a$: IF a$ = warrior$ THEN found = 1
WEND
IF NOT EOF(2) GOTO benchmark
PRINT "Can't continue.": CLOSE
KILL "warlst.tmp": KILL "benchtmp.bat"
IF sim$ = "PMARS" THEN KILL "pmarstmp.bat"
GOTO pressany

benchmark:
CLS : PRINT
PRINT "To quit press Q or delete the DeleteMe file"
PRINT "Benchmarking..."
PRINT
SHELL "echo. > DeleteMe"
exitflag = 0
WHILE NOT EOF(2) AND exitflag = 0
 ON ERROR GOTO errortrap
 LINE INPUT #2, warrior$
 IF sim$ = "Exhaust" THEN
  SHELL "benchtmp.bat " + war$ + "\" + warrior$
 ELSE
  SHELL "pmarstmp.bat " + war$ + "\" + warrior$
 END IF
 'figure out score from results.tmp
 score = 0: n = 0
 IF sim$ = "Exhaust" THEN
  OPEN "results.tmp" FOR INPUT AS #3
  WHILE NOT EOF(3)
   INPUT #3, a$: INPUT #3, bb$
   n = n + 1: z = INSTR(a$, " ")
   w = VAL(LEFT$(a$, z)): t = VAL(MID$(a$, z))
   score = score + w * 3 + t
  WEND
  CLOSE #3
 ELSE
  'trim garbage from result file (esp. if Q pressed...)
  OPEN "results.tmp" FOR INPUT AS #3
  OPEN "result1.tmp" FOR OUTPUT AS #4
  WHILE NOT EOF(3)
   LINE INPUT #3, a$
   z = INSTR(a$, "scores ")
   IF z > 1 THEN PRINT #4, a$
  WEND
  CLOSE #3: CLOSE #4
  KILL "results.tmp": NAME "result1.tmp" AS "results.tmp"
  OPEN "results.tmp" FOR INPUT AS #3
  WHILE NOT EOF(3)
   LINE INPUT #3, a$
   LINE INPUT #3, bb$
   z = INSTR(a$, "scores ")
   IF z = 0 THEN
    PRINT "Help! results corrupt"
   ELSE
    n = n + 1
    score = score + VAL(MID$(a$, z + 6))
   END IF
  WEND
  CLOSE #3
 END IF
 score = INT((score / n) * (100 / rounds) * 100) / 100
 s$ = MID$(LTRIM$(STR$(1000.005 + score)), 2, 6)
 outline$ = s$ + "  " + warrior$
 outline$ = LEFT$(outline$ + SPACE$(21), 21) + " "
 na = INT(score / 5)  'number of asteriks... 5 points each
 'score of >270 will run past column 79 but that would be a
 'really strong warrior or a bad benchmark set
 IF na > 0 THEN FOR i = 1 TO na: outline$ = outline$ + "*": NEXT i
 PRINT #1, outline$: PRINT outline$
 j$ = "x": WHILE j$ <> ""
  j$ = UCASE$(INKEY$)
  IF j$ <> "" THEN k$ = j$
 WEND
 IF k$ = "Q" THEN exitflag = 1
 ON ERROR GOTO deletemedeleted
 OPEN "DeleteMe" FOR INPUT AS #3
dmd2:
 CLOSE #3
WEND
CLOSE
KILL "results.tmp"
KILL "warlst.tmp"
KILL "benchtmp.bat"
SHELL "if exist DeleteMe del DeleteMe"
IF sim$ = "PMARS" THEN KILL "pmarstmp.bat"
pressany:
PRINT "--- press any key ---"
WHILE INKEY$ = "": WEND
GOTO menu

deletemedeleted:
exitflag = 1: RESUME dmd2

shellview:
CLS
OPEN "viewtmp.bat" FOR OUTPUT AS #1
PRINT #1, "@echo off"
PRINT #1, "type %1 | more"
PRINT #1, "pause > nul"
CLOSE #1
SHELL "viewtmp.bat " + f$
KILL "viewtmp.bat"
RETURN

viewreport:
f$ = report$
GOSUB shellview
GOTO menu

viewsorted:
SHELL "sort /r " + report$ + " >sortdrep.tmp"
f$ = "sortdrep.tmp"
GOSUB shellview
KILL "sortdrep.tmp"
GOTO menu

loadini:
ON ERROR GOTO noini
OPEN inifile$ FOR INPUT AS #1
INPUT #1, bb$ 'skip ini marker
INPUT #1, war$
INPUT #1, bench$
INPUT #1, size
INPUT #1, rounds
INPUT #1, mode$
INPUT #1, sim$
INPUT #1, report$
INPUT #1, warrior$
INPUT #1, self$
CLOSE : RETURN
noini:
RESUME noini1
noini1:
CLOSE : RETURN

saveini:
ON ERROR GOTO errortrap
OPEN inifile$ FOR OUTPUT AS #1
PRINT #1, "[Test]"
PRINT #1, war$
PRINT #1, bench$
PRINT #1, size
PRINT #1, rounds
PRINT #1, mode$
PRINT #1, sim$
PRINT #1, report$
PRINT #1, warrior$
PRINT #1, self$
PRINT #1, "[End]"
CLOSE : RETURN

'end of TEST.BAS

